package hk.quantr.fs;

import hk.quantr.Dialogs.SearchDialog;
import hk.quantr.fs.Dialogs.AutoGenerateDialog2;
import hk.quantr.fs.Dialogs.BlockDialog;
import hk.quantr.fs.Dialogs.ImportDirectoryStatusDialog;
import hk.quantr.fs.Dialogs.JumpDialog;
import hk.quantr.fs.Dialogs.NewPFSDialog;
import hk.quantr.fs.Dialogs.OpenDialog;
import hk.quantr.fs.Dialogs.PWriteDialog;
import hk.quantr.fs.Dialogs.ReadDialog;
import java.awt.Color;
import java.awt.Component;
import java.awt.HeadlessException;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.StringTokenizer;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JSplitPane;
import javax.swing.SwingUtilities;
import javax.swing.tree.TreePath;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class MainFrame2 extends javax.swing.JFrame {

	public PFSTreeModel pfsTreeModel;
	PFSTableModel pFSTableModel = new PFSTableModel();
	public boolean openImageByParameter;
	JumpDialog jJumpDialog;
	PFSTable_CellRenderer pFSTable_CellRenderer = new PFSTable_CellRenderer();
	TreePath lastSelectedTreePath;
	boolean stopFileLoading;
	PFSDefaultTreeCellRenderer pFSDefaultTreeCellRenderer = new PFSDefaultTreeCellRenderer();

	/**
	 * Creates new form MainFrame2
	 */
	public MainFrame2() {
		initComponents();
		jJumpDialog = new JumpDialog(pfsTable);
		for (int x = 0; x < pfsTable.getColumnCount(); x++) {
			pfsTable.getColumnModel().getColumn(x).setCellRenderer(pFSTable_CellRenderer);
		}

		enableUpperToolBar(false);

		setSize(600, 600);
		PFSCommonLib.centerDialog(this);
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        treePopupMenu = new javax.swing.JPopupMenu();
        addFileMenuItem = new javax.swing.JMenuItem();
        addDirectoryMenuItem = new javax.swing.JMenuItem();
        renameNodeMenuItem = new javax.swing.JMenuItem();
        deleteNodeMenuItem = new javax.swing.JMenuItem();
        deleteSubNodesMenuItem = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        importDirectoryMenuItem = new javax.swing.JMenuItem();
        importFileMenuItem = new javax.swing.JMenuItem();
        autoGenerateMenuItem = new javax.swing.JMenuItem();
        jToolBar1 = new javax.swing.JToolBar();
        newToolBarButton = new javax.swing.JButton();
        openToolBarButton = new javax.swing.JButton();
        saveToolBarButton = new javax.swing.JButton();
        settingToolBarButton = new javax.swing.JButton();
        aboutToolBarButton = new javax.swing.JButton();
        themeComboBox = new javax.swing.JComboBox<>();
        jSplitPane1 = new javax.swing.JSplitPane();
        mainTablePanel = new javax.swing.JPanel();
        scrollPane1 = new javax.swing.JScrollPane();
        pfsTable = new hk.quantr.fs.PFSTable();
        jToolBar2 = new javax.swing.JToolBar();
        modeToolBarToggleButton = new javax.swing.JButton();
        showHarddiskToolBarToggleButton = new javax.swing.JButton();
        searchToolBarButton = new javax.swing.JButton();
        hexCheckBox = new javax.swing.JCheckBox();
        decimalCheckBox = new javax.swing.JCheckBox();
        octalCheckBox = new javax.swing.JCheckBox();
        binaryCheckBox = new javax.swing.JCheckBox();
        characterCheckBox = new javax.swing.JCheckBox();
        previousBlockToolBarButton = new javax.swing.JButton();
        nextBlockToolBarButton = new javax.swing.JButton();
        jumpToolBarButton = new javax.swing.JButton();
        bottomSplitPane = new javax.swing.JSplitPane();
        directoryTreePanel = new javax.swing.JPanel();
        treeScrollPane = new javax.swing.JScrollPane();
        directoryTree = new javax.swing.JTree();
        directoryTreeToolBarPanel = new javax.swing.JPanel();
        refreshDirectoryTreeButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        pMainIconLabel = new javax.swing.JLabel();

        addFileMenuItem.setText("Add file");
        addFileMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addFileMenuItemActionPerformed(evt);
            }
        });
        treePopupMenu.add(addFileMenuItem);

        addDirectoryMenuItem.setText("Add directory");
        addDirectoryMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addDirectoryMenuItemActionPerformed(evt);
            }
        });
        treePopupMenu.add(addDirectoryMenuItem);

        renameNodeMenuItem.setText("Rename");
        renameNodeMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                renameNodeMenuItemActionPerformed(evt);
            }
        });
        treePopupMenu.add(renameNodeMenuItem);

        deleteNodeMenuItem.setText("Delete");
        deleteNodeMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteNodeMenuItemActionPerformed(evt);
            }
        });
        treePopupMenu.add(deleteNodeMenuItem);

        deleteSubNodesMenuItem.setText("Delete sub nodes");
        deleteSubNodesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteSubNodesMenuItemActionPerformed(evt);
            }
        });
        treePopupMenu.add(deleteSubNodesMenuItem);
        treePopupMenu.add(jSeparator1);

        importDirectoryMenuItem.setText("Import directory");
        importDirectoryMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                importDirectoryMenuItemActionPerformed(evt);
            }
        });
        treePopupMenu.add(importDirectoryMenuItem);

        importFileMenuItem.setText("Import file");
        importFileMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                importFileMenuItemActionPerformed(evt);
            }
        });
        treePopupMenu.add(importFileMenuItem);

        autoGenerateMenuItem.setText("Auto generate file/dir");
        autoGenerateMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                autoGenerateMenuItemActionPerformed(evt);
            }
        });
        treePopupMenu.add(autoGenerateMenuItem);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("PFSBuilder");

        jToolBar1.setRollover(true);

        newToolBarButton.setFocusable(false);
        newToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        newToolBarButton.setLabel("New");
        newToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        newToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(newToolBarButton);

        openToolBarButton.setFocusable(false);
        openToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        openToolBarButton.setLabel("Open");
        openToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        openToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(openToolBarButton);

        saveToolBarButton.setEnabled(false);
        saveToolBarButton.setFocusable(false);
        saveToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        saveToolBarButton.setLabel("Save");
        saveToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        saveToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(saveToolBarButton);

        settingToolBarButton.setEnabled(false);
        settingToolBarButton.setFocusable(false);
        settingToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        settingToolBarButton.setLabel("Setting");
        settingToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        settingToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                settingToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(settingToolBarButton);

        aboutToolBarButton.setFocusable(false);
        aboutToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        aboutToolBarButton.setLabel("About");
        aboutToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        aboutToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(aboutToolBarButton);

        themeComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "swing", "classic", "blue" }));
        themeComboBox.setMaximumSize(new java.awt.Dimension(100, 25));
        themeComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                themeComboBoxActionPerformed(evt);
            }
        });
        jToolBar1.add(themeComboBox);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.PAGE_START);

        jSplitPane1.setDividerLocation(250);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        mainTablePanel.setLayout(new java.awt.BorderLayout());

        pfsTable.setModel(pFSTableModel);
        pfsTable.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                pfsTableMouseClicked(evt);
            }
        });
        scrollPane1.setViewportView(pfsTable);

        mainTablePanel.add(scrollPane1, java.awt.BorderLayout.CENTER);

        jToolBar2.setRollover(true);

        modeToolBarToggleButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/hk/quantr/fs/images/famfamfam/box.png"))); // NOI18N
        modeToolBarToggleButton.setText("Byte");
        modeToolBarToggleButton.setFocusable(false);
        modeToolBarToggleButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        modeToolBarToggleButton.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/hk/quantr/fs/images/famfamfam/brick.png"))); // NOI18N
        modeToolBarToggleButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        modeToolBarToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                modeToolBarToggleButtonActionPerformed(evt);
            }
        });
        jToolBar2.add(modeToolBarToggleButton);

        showHarddiskToolBarToggleButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/hk/quantr/fs/images/famfamfam/table.png"))); // NOI18N
        showHarddiskToolBarToggleButton.setText("Harddisk");
        showHarddiskToolBarToggleButton.setFocusable(false);
        showHarddiskToolBarToggleButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        showHarddiskToolBarToggleButton.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/hk/quantr/fs/images/famfamfam/drive.png"))); // NOI18N
        showHarddiskToolBarToggleButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        showHarddiskToolBarToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showHarddiskToolBarToggleButtonActionPerformed(evt);
            }
        });
        jToolBar2.add(showHarddiskToolBarToggleButton);

        searchToolBarButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/hk/quantr/fs/images/famfamfam/zoom.png"))); // NOI18N
        searchToolBarButton.setText("Search");
        searchToolBarButton.setFocusable(false);
        searchToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        searchToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        searchToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar2.add(searchToolBarButton);

        hexCheckBox.setText("Hex");
        hexCheckBox.setFocusable(false);
        hexCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        hexCheckBox.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        hexCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                hexCheckBoxActionPerformed(evt);
            }
        });
        jToolBar2.add(hexCheckBox);

        decimalCheckBox.setText("Dec");
        decimalCheckBox.setFocusable(false);
        decimalCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        decimalCheckBox.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        decimalCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                decimalCheckBoxActionPerformed(evt);
            }
        });
        jToolBar2.add(decimalCheckBox);

        octalCheckBox.setText("Oct");
        octalCheckBox.setFocusable(false);
        octalCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        octalCheckBox.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        octalCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                octalCheckBoxActionPerformed(evt);
            }
        });
        jToolBar2.add(octalCheckBox);

        binaryCheckBox.setText("Bin");
        binaryCheckBox.setFocusable(false);
        binaryCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        binaryCheckBox.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        binaryCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                binaryCheckBoxActionPerformed(evt);
            }
        });
        jToolBar2.add(binaryCheckBox);

        characterCheckBox.setText("Char");
        characterCheckBox.setFocusable(false);
        characterCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        characterCheckBox.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        characterCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                characterCheckBoxActionPerformed(evt);
            }
        });
        jToolBar2.add(characterCheckBox);

        previousBlockToolBarButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/hk/quantr/fs/images/famfamfam/resultset_previous.png"))); // NOI18N
        previousBlockToolBarButton.setText("Prev");
        previousBlockToolBarButton.setFocusable(false);
        previousBlockToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        previousBlockToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        previousBlockToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                previousBlockToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar2.add(previousBlockToolBarButton);

        nextBlockToolBarButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/hk/quantr/fs/images/famfamfam/resultset_next.png"))); // NOI18N
        nextBlockToolBarButton.setText("Next");
        nextBlockToolBarButton.setFocusable(false);
        nextBlockToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        nextBlockToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        nextBlockToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextBlockToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar2.add(nextBlockToolBarButton);

        jumpToolBarButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/hk/quantr/fs/images/famfamfam/zoom.png"))); // NOI18N
        jumpToolBarButton.setText("Jump");
        jumpToolBarButton.setFocusable(false);
        jumpToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jumpToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jumpToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jumpToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar2.add(jumpToolBarButton);

        mainTablePanel.add(jToolBar2, java.awt.BorderLayout.PAGE_START);

        jSplitPane1.setTopComponent(mainTablePanel);

        bottomSplitPane.setDividerLocation(250);

        directoryTreePanel.setLayout(new java.awt.BorderLayout());

        directoryTree.setModel(null);
        directoryTree.setCellRenderer(pFSDefaultTreeCellRenderer);
        directoryTree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                directoryTreeMouseClicked(evt);
            }
        });
        treeScrollPane.setViewportView(directoryTree);

        directoryTreePanel.add(treeScrollPane, java.awt.BorderLayout.CENTER);

        refreshDirectoryTreeButton.setText("Refresh");
        refreshDirectoryTreeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                refreshDirectoryTreeButtonActionPerformed(evt);
            }
        });
        directoryTreeToolBarPanel.add(refreshDirectoryTreeButton);

        directoryTreePanel.add(directoryTreeToolBarPanel, java.awt.BorderLayout.NORTH);

        bottomSplitPane.setLeftComponent(directoryTreePanel);

        jPanel1.setLayout(new java.awt.BorderLayout());
        jPanel1.add(pMainIconLabel, java.awt.BorderLayout.CENTER);

        bottomSplitPane.setRightComponent(jPanel1);

        jSplitPane1.setRightComponent(bottomSplitPane);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void aboutToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutToolBarButtonActionPerformed
		new AboutBox2(this, true).setVisible(true);
    }//GEN-LAST:event_aboutToolBarButtonActionPerformed

    private void newToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newToolBarButtonActionPerformed
		NewPFSDialog newPFSDialog = new NewPFSDialog(this, "New PFS", true, true);
		newPFSDialog.setVisible(true);
		if (newPFSDialog.isCancel() == false) {
			if (updateVariables(newPFSDialog)) {
				directoryTree.setBackground(Color.white);
				pfsTable.setBackground(Color.white);
				scrollPane1.getViewport().setBackground(Color.white);
				pfsTreeModel = new PFSTreeModel(PFSSettingConstants.tempDirectory);
				pFSTableModel.setValue(null);
				directoryTree.setModel(pfsTreeModel);

				saveToolBarButton.setEnabled(true);
				pfsTable.setEnabled(false);
				settingToolBarButton.setEnabled(true);
				directoryTree.setEnabled(true);
				refreshDirectoryTreeButton.setEnabled(true);
				enableUpperToolBar(false);

				initINIFile();
			}
		}
    }//GEN-LAST:event_newToolBarButtonActionPerformed

	public void openToolBarButton_actionPerformed(ActionEvent evt) {
		openToolBarButtonActionPerformed(evt);
	}

    private void openToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openToolBarButtonActionPerformed
		OpenDialog openDialog = new OpenDialog(this);
		if (!openImageByParameter) {
			openDialog.setVisible(true);
		}
		if (openImageByParameter || !openDialog.isCancel) {
			try {
				if (!openImageByParameter) {
					if (new File(openDialog.tempDirectoryLabel.getText()).exists()) {
						int returnValue = JOptionPane.showConfirmDialog(this, openDialog.tempDirectoryLabel.getText() + " exist, remove it?", "Question",
								JOptionPane.YES_NO_OPTION);
						if (returnValue == JOptionPane.YES_OPTION) {
							PFSCommonLib.deleteDirectory(openDialog.tempDirectoryLabel.getText());
						}
					}
					new File(openDialog.tempDirectoryLabel.getText()).mkdir();
					if (openDialog.radioButton1.isSelected()) {
						String offsetText = openDialog.partitionOffsetTextField.getText();
						try {
							PFSImageConstants.partitionOffset = Long.parseLong(offsetText);
						} catch (Exception ex) {
							PFSImageConstants.partitionOffset = PFSCommonLib.convertFilesize(offsetText);
						}
					} else {
						String offsetText = openDialog.offsetComboBox.getItemAt(openDialog.offsetComboBox.getSelectedIndex()).toString();

						if (offsetText.indexOf(":") != -1) {
							offsetText = offsetText.substring(0, offsetText.indexOf(":"));
						}
						PFSImageConstants.partitionOffset = Long.parseLong(offsetText);
					}

					PFSImageConstants.filename = openDialog.pfsFileLabel.getText();
					PFSSettingConstants.filename = PFSImageConstants.filename;

					PFSSettingConstants.partitionOffset = PFSImageConstants.partitionOffset;

					PFSImageConstants.partitionSize = new File(PFSImageConstants.filename).length() - PFSImageConstants.partitionOffset;
					PFSSettingConstants.partitionSize = PFSImageConstants.partitionSize;

					PFSSettingConstants.tempDirectory = openDialog.tempDirectoryLabel.getText();
					PFSSettingConstants.projectFile = openDialog.pProjectFileLabel.getText();
				}
				ReadDialog readDialog = new ReadDialog(this, "Reading PFS...", true);
				readDialog.setVisible(true);

				directoryTree.setBackground(Color.white);
				pfsTreeModel = new PFSTreeModel(PFSSettingConstants.tempDirectory);
				directoryTree.setModel(pfsTreeModel);
				pFSTableModel.setValue(PFSImageConstants.filename);

				saveToolBarButton.setEnabled(true);
				pfsTable.setEnabled(true);
				directoryTree.setEnabled(true);
				settingToolBarButton.setEnabled(true);
				enableUpperToolBar(true);
				refreshDirectoryTreeButton.setEnabled(true);
				openImageByParameter = false;
			} catch (Exception ex) {
				ex.printStackTrace();
				if (Global.GUI) {
					new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
				}
			}
		}
    }//GEN-LAST:event_openToolBarButtonActionPerformed

    private void saveToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveToolBarButtonActionPerformed
		PWriteDialog pWriteDialog = new PWriteDialog(this, "Writing...", true);
		pWriteDialog.setVisible(true);

		PFSImageConstants.filename = PFSSettingConstants.filename;
		PFSImageConstants.blockSize = PFSSettingConstants.blockSize;
		PFSImageConstants.partitionSize = PFSSettingConstants.partitionSize;
		PFSImageConstants.partitionOffset = PFSSettingConstants.partitionOffset;

		pFSTableModel.setValue(PFSImageConstants.filename);
		pfsTable.setEnabled(true);
		enableUpperToolBar(true);
    }//GEN-LAST:event_saveToolBarButtonActionPerformed

    private void settingToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_settingToolBarButtonActionPerformed
		NewPFSDialog jNewPFSDialog = new NewPFSDialog(this, "Change PFS", true, false);
		jNewPFSDialog.setVisible(true);
		if (jNewPFSDialog.isCancel() == false && jNewPFSDialog.getOutputFilename() != null && jNewPFSDialog.getProjectFile() != null) {
			// if (jNewPFSDialog.isCancel() == false &&
			// jNewPFSDialog.getOutputFilename() != null &&
			// jNewPFSDialog.getProjectFile() != null) {
			updateVariables(jNewPFSDialog);
		}
    }//GEN-LAST:event_settingToolBarButtonActionPerformed

    private void themeComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_themeComboBoxActionPerformed
		System.out.println(themeComboBox.getSelectedItem().toString());
		// PetersoftJavaStyle.setStyle(pThemeComboBox.getSelectedItem().toString());
		this.repaint();
    }//GEN-LAST:event_themeComboBoxActionPerformed

    private void refreshDirectoryTreeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshDirectoryTreeButtonActionPerformed
		TreePath lastSelectedTreePath = directoryTree.getSelectionPath();
		pfsTreeModel = new PFSTreeModel(PFSSettingConstants.tempDirectory);
		directoryTree.setModel(pfsTreeModel);
		directoryTree.setSelectionPath(lastSelectedTreePath);
    }//GEN-LAST:event_refreshDirectoryTreeButtonActionPerformed

    private void modeToolBarToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_modeToolBarToggleButtonActionPerformed
		try {
			int row = pfsTable.getSelectedRow();
			int column = pfsTable.getSelectedColumn();
			int columnCount = pfsTable.getColumnCount();

			if (pFSTableModel.getMode() == 0) {
				pFSTableModel.setMode(1);

				long offset = row * (columnCount - 1) + (column - 1);
				int blockNumber = (int) offset / PFSImageConstants.blockSize;
				int selectRowNumber = blockNumber / (columnCount - 1);
				int selectColumnNumber = blockNumber - (selectRowNumber * (columnCount - 1));
				if (selectRowNumber > 0 && selectRowNumber < pfsTable.getRowCount() && (selectColumnNumber + 1) > 0 && (selectColumnNumber + 1) < pfsTable.getColumnCount()) {
					pfsTable.selectAndVisibleRow(selectRowNumber, selectColumnNumber + 1);
				}
				modeToolBarToggleButton.setText("Block");
			} else if (pFSTableModel.getMode() == 1) {
				pFSTableModel.setMode(0);

				int blockNumber = (row * (columnCount - 1)) + column - 1;
				long offset = blockNumber * PFSImageConstants.blockSize;
				int selectRowNumber = (int) offset / (columnCount - 1);
				int selectColumnNumber = (int) offset - selectRowNumber * (columnCount - 1);
				if (selectRowNumber > 0 && selectRowNumber < pfsTable.getRowCount() && (selectColumnNumber + 1) > 0 && (selectColumnNumber + 1) < pfsTable.getColumnCount()) {
					pfsTable.selectAndVisibleRow(selectRowNumber, selectColumnNumber + 1);
				}
				modeToolBarToggleButton.setText("Byte");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			if (Global.GUI) {
				new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
			}
		}
    }//GEN-LAST:event_modeToolBarToggleButtonActionPerformed

    private void showHarddiskToolBarToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showHarddiskToolBarToggleButtonActionPerformed
		if (showHarddiskToolBarToggleButton.isSelected()) {
			// show partition only
			showHarddiskToolBarToggleButton.setText("Partition");
			pFSTableModel.setShowOffset(PFSImageConstants.partitionOffset);
		} else {
			// show all harddisk image
			showHarddiskToolBarToggleButton.setText("Harddisk");
			pFSTableModel.setShowOffset(0);
		}
    }//GEN-LAST:event_showHarddiskToolBarToggleButtonActionPerformed

    private void searchToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchToolBarButtonActionPerformed
		new SearchDialog(this, "Search", true).setVisible(true);
    }//GEN-LAST:event_searchToolBarButtonActionPerformed

    private void hexCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_hexCheckBoxActionPerformed
		this.pFSTableModel.setShowHex(hexCheckBox.isSelected());
    }//GEN-LAST:event_hexCheckBoxActionPerformed

    private void decimalCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_decimalCheckBoxActionPerformed
		this.pFSTableModel.setShowDecimal(decimalCheckBox.isSelected());
    }//GEN-LAST:event_decimalCheckBoxActionPerformed

    private void octalCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_octalCheckBoxActionPerformed
		this.pFSTableModel.setShowOctal(octalCheckBox.isSelected());
    }//GEN-LAST:event_octalCheckBoxActionPerformed

    private void binaryCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_binaryCheckBoxActionPerformed
		this.pFSTableModel.setShowBinary(binaryCheckBox.isSelected());
    }//GEN-LAST:event_binaryCheckBoxActionPerformed

    private void characterCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_characterCheckBoxActionPerformed
		this.pFSTableModel.setShowCharacter(characterCheckBox.isSelected());
    }//GEN-LAST:event_characterCheckBoxActionPerformed

    private void previousBlockToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_previousBlockToolBarButtonActionPerformed
		int columnCount = pfsTable.getColumnCount();
		int rowCount = pfsTable.getRowCount();
		int selectedRow = pfsTable.getSelectedRow();
		int selectedColumn = pfsTable.getSelectedColumn();

		if (pFSTableModel.getMode() == 0) {
			int newRowNumber = selectedRow - PFSImageConstants.blockSize / (columnCount - 1);
			if (newRowNumber < 0 || newRowNumber >= rowCount) {
				return;
			}
			pfsTable.setRowSelectionInterval(newRowNumber, newRowNumber);
			scrollPane1.getViewport().setViewPosition(new Point(0, pfsTable.getMaximumSize().height));
		} else if (pFSTableModel.getMode() == 1) {
			if (selectedColumn != 1) {
				pfsTable.setColumnSelectionInterval(selectedColumn - 1, selectedColumn - 1);
			} else {
				pfsTable.setColumnSelectionInterval(columnCount - 1, columnCount - 1);
				pfsTable.setRowSelectionInterval(selectedRow - 1, selectedRow - 1);
			}
		}
    }//GEN-LAST:event_previousBlockToolBarButtonActionPerformed

    private void nextBlockToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextBlockToolBarButtonActionPerformed
		int columnCount = pfsTable.getColumnCount();
		int rowCount = pfsTable.getRowCount();
		int selectedRow = pfsTable.getSelectedRow();
		int selectedColumn = pfsTable.getSelectedColumn();

		if (selectedRow == -1) {
			pfsTable.setRowSelectionInterval(0, 0);
			pfsTable.setColumnSelectionInterval(1, 1);
			selectedRow = 0;
			selectedColumn = 1;
		}

		if (pFSTableModel.getMode() == 0) {
			int newRowNumber = selectedRow + PFSImageConstants.blockSize / (columnCount - 1);
			if (newRowNumber < pfsTable.getRowCount()) {
				pfsTable.setRowSelectionInterval(newRowNumber, newRowNumber);
				pfsTable.selectAndVisibleRow(newRowNumber, selectedColumn);
			}
		} else if (pFSTableModel.getMode() == 1) {
			if (selectedColumn != columnCount - 1) {
				pfsTable.setColumnSelectionInterval(selectedColumn + 1, selectedColumn + 1);
			} else {
				pfsTable.setColumnSelectionInterval(1, 1);
				pfsTable.setRowSelectionInterval(selectedRow + 1, selectedRow + 1);
				pfsTable.selectAndVisibleRow(selectedRow + 1, selectedColumn);
			}
		}
    }//GEN-LAST:event_nextBlockToolBarButtonActionPerformed

    private void jumpToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jumpToolBarButtonActionPerformed
		if (jJumpDialog.isVisible()) {
			jJumpDialog.toFront();
		} else {
			jJumpDialog.setVisible(true);
		}
    }//GEN-LAST:event_jumpToolBarButtonActionPerformed

    private void directoryTreeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_directoryTreeMouseClicked
		Component component = bottomSplitPane.getRightComponent();
		if (component.getClass() == PFSFilePropertyPanel.class) {
			PFSFilePropertyPanel pFSFilePropertyPanel = (PFSFilePropertyPanel) bottomSplitPane.getRightComponent();
			if (pFSFilePropertyPanel.shouldSave) {
				int returnValue = JOptionPane.showConfirmDialog(this, "Save file?", "Question", JOptionPane.YES_NO_CANCEL_OPTION);
				if (returnValue == JOptionPane.YES_OPTION) {
					pFSFilePropertyPanel.saveFile();
				} else if (returnValue == JOptionPane.CANCEL_OPTION) {
					directoryTree.setSelectionPath(lastSelectedTreePath);
					return;
				}
			}
		}

		if (directoryTree.isEnabled()) {
			TreePath selectedPath = directoryTree.getPathForLocation(evt.getX(), evt.getY());
			if (selectedPath != null) {
				if (SwingUtilities.isRightMouseButton(evt)) {
					// right mouse click
					// updateTextToNode();

					// check is node selected
					boolean nodeSelected = false;
					TreePath selectedTreePaths[] = directoryTree.getSelectionPaths();
					if (selectedTreePaths != null) {
						for (int x = 0; x < selectedTreePaths.length; x++) {
							if (selectedTreePaths[x] == selectedPath) {
								nodeSelected = true;
								break;
							}
						}
					}
					// end check is node selected
					boolean isRoot = (pfsTreeModel.getRoot() == selectedPath.getLastPathComponent()) ? true : false;
					if (!nodeSelected || isRoot) {
						directoryTree.setSelectionPath(selectedPath);
					}
					if (isRoot) {
						this.deleteNodeMenuItem.setEnabled(false);
						this.renameNodeMenuItem.setEnabled(false);
					} else {
						this.deleteNodeMenuItem.setEnabled(true);
						this.renameNodeMenuItem.setEnabled(true);
					}
					if (((File) selectedPath.getLastPathComponent()).isFile()) {
						this.addDirectoryMenuItem.setEnabled(false);
						this.addFileMenuItem.setEnabled(false);
					} else {
						this.addDirectoryMenuItem.setEnabled(true);
						this.addFileMenuItem.setEnabled(true);
					}
					treePopupMenu.show(evt.getComponent(), evt.getX(), evt.getY());
				} else {
					// left mouse click
					stopFileLoading = false;
					if (directoryTree.getSelectionPath() != null) {
						File selectedFile = (File) directoryTree.getSelectionPath().getLastPathComponent();
						// if (selectedFile.toString().equals(
						// PFSSettingConstants.tempDirectory)) {
						// } else {
						enableEditorToolbarButtons(selectedFile.isFile());
						if (selectedFile.isFile()) {
							PFSFilePropertyPanel2 pFSFilePropertyPanel = new PFSFilePropertyPanel2(this, PFSSettingConstants.projectFile, selectedFile);
							addComponentToBottomSplitPane(pFSFilePropertyPanel);
							if (selectedFile.length() <= 1024 * 1024 * 10) {
								pFSFilePropertyPanel.loadFile();
							} else {
								JOptionPane.showMessageDialog(this, "Unable to open >10MB file", "Warning", JOptionPane.WARNING_MESSAGE);
							}
						} else {
							PFSDirectoryPropertyPanel pFSDirectoryPropertyPanel = new PFSDirectoryPropertyPanel(PFSSettingConstants.projectFile, selectedFile.getAbsolutePath());
							addComponentToBottomSplitPane(pFSDirectoryPropertyPanel);
						}
						// }
					}
				}
			}
		}
		lastSelectedTreePath = directoryTree.getSelectionPath();
    }//GEN-LAST:event_directoryTreeMouseClicked

    private void addFileMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addFileMenuItemActionPerformed
		TreePath selectedPath = directoryTree.getSelectionPath();
		if (selectedPath != null) {
			String str = JOptionPane.showInputDialog(this, "Input filename", "Add file", JOptionPane.QUESTION_MESSAGE);

			if (str == null) {
				return;
			} else {
				try {
					File node = (File) selectedPath.getLastPathComponent();
					File newFile = new File(node + File.separator + str);
					if (!newFile.createNewFile()) {
						JOptionPane.showMessageDialog(this, "Cannot create File", "Error", JOptionPane.ERROR_MESSAGE);
						return;
					}

					pfsTreeModel.fireTreeStructureChanged(node);
					directoryTree.setSelectionPath(pfsTreeModel.getTreePath(newFile));
					lastSelectedTreePath = directoryTree.getSelectionPath();
					PFSFilePropertyPanel2 pFSFilePropertyPanel = new PFSFilePropertyPanel2(this, PFSSettingConstants.projectFile, newFile);
					addComponentToBottomSplitPane(pFSFilePropertyPanel);
					this.enableEditorToolbarButtons(true);
				} catch (Exception ex) {
					JOptionPane.showMessageDialog(this, "Cannot create File", "Error", JOptionPane.ERROR_MESSAGE);
					return;
				}
			}
		}
    }//GEN-LAST:event_addFileMenuItemActionPerformed

    private void addDirectoryMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addDirectoryMenuItemActionPerformed
		TreePath selectedPath = directoryTree.getSelectionPath();
		if (selectedPath != null) {
			String str = JOptionPane.showInputDialog(this, "Input directory name", "Add directory", JOptionPane.QUESTION_MESSAGE);

			if (str == null) {
				return;
			} else {
				try {
					File node = (File) selectedPath.getLastPathComponent();
					File newDirectory = new File(node + File.separator + str);
					if (!newDirectory.mkdir()) {
						JOptionPane.showMessageDialog(this, "Cannot create directory", "Error", JOptionPane.ERROR_MESSAGE);
						return;
					}
					pfsTreeModel.fireTreeStructureChanged(node);
					directoryTree.setSelectionPath(pfsTreeModel.getTreePath(newDirectory));
					lastSelectedTreePath = directoryTree.getSelectionPath();

					PFSDirectoryPropertyPanel pFSDirectoryPropertyPanel = new PFSDirectoryPropertyPanel(PFSSettingConstants.projectFile, newDirectory.getAbsolutePath());
					addComponentToBottomSplitPane(pFSDirectoryPropertyPanel);
					this.enableEditorToolbarButtons(true);
				} catch (Exception ex) {
					JOptionPane.showMessageDialog(this, "Cannot create directory", "Error", JOptionPane.ERROR_MESSAGE);
					return;
				}
			}
		}
    }//GEN-LAST:event_addDirectoryMenuItemActionPerformed

    private void renameNodeMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_renameNodeMenuItemActionPerformed
		TreePath selectedPath = directoryTree.getSelectionPath();
		if (selectedPath != null) {
			Object str = showInputDialog(this, "?", "Rename file : ", ((File) selectedPath.getLastPathComponent()).getName());
			if (str != null) {
				File node = (File) selectedPath.getLastPathComponent();
				File newFile = new File(node.getParentFile().getAbsolutePath() + File.separator + str);

				node.renameTo(newFile);

				if (bottomSplitPane.getClass().equals(PFSFilePropertyPanel.class)) {
					PFSFilePropertyPanel pFSFilePropertyPanel = (PFSFilePropertyPanel) bottomSplitPane.getRightComponent();
					pFSFilePropertyPanel.renameFileTo(newFile);

					pfsTreeModel.fireTreeStructureChanged(node);
				}
				this.refreshDirectoryTreeButtonActionPerformed(null);
			}
		}
    }//GEN-LAST:event_renameNodeMenuItemActionPerformed

    private void deleteNodeMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteNodeMenuItemActionPerformed
		int str = JOptionPane.showConfirmDialog(this, "Sure to delete : " + ((File) directoryTree.getLastSelectedPathComponent()).getName(), "?", JOptionPane.WARNING_MESSAGE);
		if (str == JOptionPane.YES_OPTION) {
			TreePath selectedTreePaths[] = directoryTree.getSelectionPaths();
			for (int x = 0; x < selectedTreePaths.length; x++) {
				File file = (File) selectedTreePaths[x].getLastPathComponent();
				if (file.isFile()) {
					if (!file.delete()) {
						JOptionPane.showMessageDialog(this, "Fail to delete file : " + file.getAbsolutePath(), "Error", JOptionPane.ERROR_MESSAGE);
					}
				} else {
					PFSCommonLib.deleteDirectory(file);
				}
			}
			this.refreshDirectoryTreeButtonActionPerformed(null);
		}
    }//GEN-LAST:event_deleteNodeMenuItemActionPerformed

    private void deleteSubNodesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteSubNodesMenuItemActionPerformed
		TreePath selectedPath = directoryTree.getSelectionPath();
		if (selectedPath != null) {
			if (selectedPath == null) { // Path not found because
				return; // right click does not occur on a node or a leaf
			}

			File node = (File) directoryTree.getLastSelectedPathComponent();
			File nodes[] = node.listFiles();
			for (int x = 0; x < nodes.length; x++) {
				if (nodes[x].isDirectory()) {
					PFSCommonLib.deleteDirectory(nodes[x]);
				} else {
					nodes[x].delete();
				}
			}
			pfsTreeModel.fireTreeStructureChanged(node);
		}
    }//GEN-LAST:event_deleteSubNodesMenuItemActionPerformed

    private void importDirectoryMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_importDirectoryMenuItemActionPerformed
		TreePath selectedPath = directoryTree.getSelectionPath();
		if (selectedPath != null) {
			JFileChooser pFileChooserDialog = new JFileChooser();
			pFileChooserDialog.setMultiSelectionEnabled(true);
			pFileChooserDialog.setSize(500, 500);
			PFSCommonLib.centerDialog(pFileChooserDialog);
			pFileChooserDialog.setFileSelectionMode(pFileChooserDialog.DIRECTORIES_ONLY);
//			pFileChooserDialog.setAcceptAllFileFilterUsed(false);

			if (pFileChooserDialog.showOpenDialog(this) == pFileChooserDialog.APPROVE_OPTION) {
				File files[] = pFileChooserDialog.getSelectedFiles();

				if (files.length > 0) {
					File node = (File) selectedPath.getLastPathComponent();
					ImportDirectoryStatusDialog jImportDirectoryStatusDialog = new ImportDirectoryStatusDialog(this, "Import directory", true, node, files);
					PFSCommonLib.centerDialog(jImportDirectoryStatusDialog);
					jImportDirectoryStatusDialog.setVisible(true);
					pfsTreeModel.fireTreeStructureChanged(node);
				}
			}
		}
    }//GEN-LAST:event_importDirectoryMenuItemActionPerformed

    private void autoGenerateMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_autoGenerateMenuItemActionPerformed
		new AutoGenerateDialog2(this, this.directoryTree, PFSSettingConstants.projectFile).setVisible(true);
    }//GEN-LAST:event_autoGenerateMenuItemActionPerformed

    private void pfsTableMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_pfsTableMouseClicked
		if (evt.getClickCount() == 2) {
			if (pFSTableModel.getMode() == 1) {
				long fileOffset = pfsTable.getSelectedRow() * (pfsTable.getColumnCount() - 1) * PFSImageConstants.blockSize;
				if (fileOffset >= PFSImageConstants.partitionOffset - pFSTableModel.getShowOffset()
						&& fileOffset <= PFSImageConstants.partitionSize + PFSImageConstants.partitionOffset - pFSTableModel.getShowOffset()) {
					long blockNo = pfsTable.getSelectedRow() * (pfsTable.getColumnCount() - 1) + pfsTable.getSelectedColumn() - 2;
					new BlockDialog(this, String.valueOf(blockNo), (byte[]) pfsTable.getValueAt(pfsTable.getSelectedRow(), pfsTable.getSelectedColumn())).setVisible(true);
				}
			}
		}
    }//GEN-LAST:event_pfsTableMouseClicked

    private void importFileMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_importFileMenuItemActionPerformed
		TreePath selectedPath = directoryTree.getSelectionPath();
		if (selectedPath != null) {
			JFileChooser pFileChooserDialog = new JFileChooser();
			pFileChooserDialog.setMultiSelectionEnabled(true);
			pFileChooserDialog.setSize(500, 500);
			PFSCommonLib.centerDialog(pFileChooserDialog);
			pFileChooserDialog.setFileSelectionMode(pFileChooserDialog.FILES_ONLY);
//			pFileChooserDialog.setAcceptAllFileFilterUsed(false);

			if (pFileChooserDialog.showOpenDialog(this) == pFileChooserDialog.APPROVE_OPTION) {
				File files[] = pFileChooserDialog.getSelectedFiles();

				if (files.length > 0) {
					File node = (File) selectedPath.getLastPathComponent();
					ImportDirectoryStatusDialog jImportDirectoryStatusDialog = new ImportDirectoryStatusDialog(this, "Import file", true, node, files);
					PFSCommonLib.centerDialog(jImportDirectoryStatusDialog);
					jImportDirectoryStatusDialog.setVisible(true);
					pfsTreeModel.fireTreeStructureChanged(node);
				}
			}
		}
    }//GEN-LAST:event_importFileMenuItemActionPerformed

	private boolean updateVariables(NewPFSDialog newPFSDialog) {
		if (newPFSDialog.getOutputFilename() != null) {
			PFSSettingConstants.filename = newPFSDialog.getOutputFilename();
			PFSSettingConstants.projectFile = newPFSDialog.getProjectFile();
			if (!new File(PFSSettingConstants.projectFile).getParentFile().exists()) {
				if (!new File(PFSSettingConstants.projectFile).getParentFile().mkdirs()) {
					JOptionPane.showMessageDialog(this, PFSSettingConstants.projectFile + " cannot be created !!!", "Error", JOptionPane.ERROR_MESSAGE);
					return false;
				}
			}

			PFSSettingConstants.partitionOffset = Long.parseLong(newPFSDialog.getPartitionOffset());
			PFSSettingConstants.partitionName = newPFSDialog.getPartitionName();
			PFSSettingConstants.partitionSize = Long.parseLong(newPFSDialog.getPartitionSize());
			StringTokenizer stk = new StringTokenizer(newPFSDialog.getBlockSize(), " ");
			PFSSettingConstants.blockSize = Integer.parseInt(stk.nextToken()) * 1024;
			PFSSettingConstants.version = newPFSDialog.getVersion();
			PFSSettingConstants.C = newPFSDialog.getC();
			PFSSettingConstants.H = newPFSDialog.getH();
			PFSSettingConstants.S = newPFSDialog.getS();
			PFSSettingConstants.tempDirectory = newPFSDialog.getTempDirectory();
			if (!new File(PFSSettingConstants.tempDirectory).exists()) {
				if (!new File(PFSSettingConstants.tempDirectory).mkdirs()) {
					JOptionPane.showMessageDialog(this, PFSSettingConstants.tempDirectory + " cannot be created !!!", "Error", JOptionPane.ERROR_MESSAGE);

					return false;
				}
			}
			return true;
		} else {
			JOptionPane.showMessageDialog(this, "Output filename is null", "Error", JOptionPane.ERROR_MESSAGE);

			return false;
		}
	}

	private void initINIFile() {
		PIni ini = new PIni("Setting.ini");
		// ini.removeProperty("Last opened project file","path");
		ini.setStringProperty("Last opened project file", "path", System.getProperty("user.dir"), null);
		// ini.removeProperty("Last opened PFS image","path");
		ini.setStringProperty("Last opened PFS image", "path", System.getProperty("user.dir"), null);
		ini.save();

		new File(PFSSettingConstants.projectFile).delete();
	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		/* Set the Nimbus look and feel */
		//<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
		/* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
		 */
		try {
			for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
				if ("Nimbus".equals(info.getName())) {
					javax.swing.UIManager.setLookAndFeel(info.getClassName());
					break;
				}
			}
		} catch (ClassNotFoundException ex) {
			java.util.logging.Logger.getLogger(MainFrame2.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (InstantiationException ex) {
			java.util.logging.Logger.getLogger(MainFrame2.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (IllegalAccessException ex) {
			java.util.logging.Logger.getLogger(MainFrame2.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (javax.swing.UnsupportedLookAndFeelException ex) {
			java.util.logging.Logger.getLogger(MainFrame2.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		//</editor-fold>

		/* Create and display the form */
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new MainFrame2().setVisible(true);
			}
		});
	}

	private void enableUpperToolBar(boolean b) {
		showHarddiskToolBarToggleButton.setEnabled(b);
		modeToolBarToggleButton.setEnabled(b);
		searchToolBarButton.setEnabled(b);
		hexCheckBox.setEnabled(b);
		decimalCheckBox.setEnabled(b);
		octalCheckBox.setEnabled(b);
		binaryCheckBox.setEnabled(b);
		characterCheckBox.setEnabled(b);
		previousBlockToolBarButton.setEnabled(b);
		nextBlockToolBarButton.setEnabled(b);
		jumpToolBarButton.setEnabled(b);
	}

	private void addComponentToBottomSplitPane(Component component) {
		int dividerLocation = bottomSplitPane.getDividerLocation();
		bottomSplitPane.add(component, JSplitPane.RIGHT);
		bottomSplitPane.setDividerLocation(dividerLocation);
	}

	private void enableEditorToolbarButtons(boolean b) {
	}

	public Object showInputDialog(Component parentComponent, String title, Object message, String initialSelectionValue) throws HeadlessException {
		JOptionPane pane = new JOptionPane("rename file", JOptionPane.QUESTION_MESSAGE, JOptionPane.OK_CANCEL_OPTION, null, null, null);
		pane.setWantsInput(true);
		pane.setInitialSelectionValue(initialSelectionValue);
		pane.setComponentOrientation(parentComponent.getComponentOrientation());
		JDialog dialog = pane.createDialog(parentComponent, "?");
		pane.selectInitialValue();
		dialog.setVisible(true);
		Object value = pane.getInputValue();
		if (value == "uninitializedValue") {
			return null;
		}
		return value;
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton aboutToolBarButton;
    private javax.swing.JMenuItem addDirectoryMenuItem;
    private javax.swing.JMenuItem addFileMenuItem;
    private javax.swing.JMenuItem autoGenerateMenuItem;
    private javax.swing.JCheckBox binaryCheckBox;
    private javax.swing.JSplitPane bottomSplitPane;
    private javax.swing.JCheckBox characterCheckBox;
    private javax.swing.JCheckBox decimalCheckBox;
    private javax.swing.JMenuItem deleteNodeMenuItem;
    private javax.swing.JMenuItem deleteSubNodesMenuItem;
    private javax.swing.JTree directoryTree;
    private javax.swing.JPanel directoryTreePanel;
    private javax.swing.JPanel directoryTreeToolBarPanel;
    private javax.swing.JCheckBox hexCheckBox;
    private javax.swing.JMenuItem importDirectoryMenuItem;
    private javax.swing.JMenuItem importFileMenuItem;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JToolBar jToolBar2;
    private javax.swing.JButton jumpToolBarButton;
    private javax.swing.JPanel mainTablePanel;
    private javax.swing.JButton modeToolBarToggleButton;
    private javax.swing.JButton newToolBarButton;
    private javax.swing.JButton nextBlockToolBarButton;
    private javax.swing.JCheckBox octalCheckBox;
    private javax.swing.JButton openToolBarButton;
    private javax.swing.JLabel pMainIconLabel;
    private hk.quantr.fs.PFSTable pfsTable;
    private javax.swing.JButton previousBlockToolBarButton;
    private javax.swing.JButton refreshDirectoryTreeButton;
    private javax.swing.JMenuItem renameNodeMenuItem;
    private javax.swing.JButton saveToolBarButton;
    private javax.swing.JScrollPane scrollPane1;
    private javax.swing.JButton searchToolBarButton;
    private javax.swing.JButton settingToolBarButton;
    private javax.swing.JButton showHarddiskToolBarToggleButton;
    private javax.swing.JComboBox<String> themeComboBox;
    private javax.swing.JPopupMenu treePopupMenu;
    private javax.swing.JScrollPane treeScrollPane;
    // End of variables declaration//GEN-END:variables

}
